var React      = require('react');
var classNames = require('classNames');

var App = React.createClass({
  getInitialState: function() {
    return {
      todos: {
        1: { complete: true,  text: "アウトライン書く" },
        2: { complete: false, text: "サンプルコード作る" },
        3: { complete: false, text: "Pull Request する" }
      }
    };
  },

  addItem: function(text) {
    var id = this.state.todos.length + 1;
    var todo = { complete: false, text: text };
    this.state.todos[id] = todo;
    this.setState({ todos: this.state.todos });
  },

  toggleComplete: function(id) {
    var todo = this.state.todos[id];
    if (todo.complete) {
      todo.complete = false;
    } else {
      todo.complete = true;
    }
    this.setState({ todos: this.state.todos });
  },

  render: function() {
    return (
      <div>
        <TodoInput onKeyDown={this.addItem} />
        <TodoList todos={this.state.todos}
                  onToggleComplete={this.toggleComplete} />
      </div>
    );
  }
});

var TodoInput = React.createClass({
  propTypes: {
    onKeyDown: React.PropTypes.func.isRequired
  },

  _onKeyDown: function(e) {
    if (e.keyCode === 13) {
      this.props.onKeyDown(e.target.value);
      e.target.value = '';
    }
  },

  render: function() {
    return <input type="text" onKeyDown={this._onKeyDown} />;
  }
});

var TodoList = React.createClass({
  propTypes: {
    todos:            React.PropTypes.object.isRequired,
    onToggleComplete: React.PropTypes.func.isRequired
  },

  render: function() {
    var todos = [];
    for (var id in this.props.todos) {
      var todo = this.props.todos[id];
      todos.push(
        <Todo key={id}
              id={id}
              text={todo.text}
              complete={todo.complete}
              onToggleComplete={this.props.onToggleComplete}
              />
      );
    }
    return <ul>{todos}</ul>;
  }
});

var Todo = React.createClass({
  propTypes: {
    text:             React.PropTypes.string.isRequired,
    id:               React.PropTypes.string.isRequired,
    complete:         React.PropTypes.bool.isRequired,
    onToggleComplete: React.PropTypes.func.isRequired
  },

  _onChange: function() {
    this.props.onToggleComplete(this.props.id);
  },

  render: function() {
    return (
      <li className={classNames({ completed: this.props.complete })}>
        <input type="checkbox"
               checked={this.props.complete}
               onChange={this._onChange} />
        {this.props.text}
      </li>
    );
  }
});

React.render(
  <App />,
  document.getElementById('app-container')
);
